<template>
  <app-container>
    <search-area :need-search-more="false" type="default" size="small" @search="search">
      <search-item >
        <el-date-picker
          v-model="timeRange"
          :picker-options="pickerOptions"
          type="daterange"
          size="small"
          range-separator="至"
          value-format="yyyy-MM-dd"
          start-placeholder="开始日期"
          end-placeholder="结束日期"/>
      </search-item>
    </search-area>
    <div class="tab-block">
      <el-tabs v-model="activeName" type="card" @tab-click="handleClick">
        <el-tab-pane name="list">
          <span slot="label"><i class="el-icon-s-fold"/> 列表模式</span>
          <high-freq-list :list="list"/>
        </el-tab-pane>
        <el-tab-pane name="chart">
          <span slot="label"><i class="el-icon-s-data"/> 图表模式</span>
          <high-freq-chart :list="listMajor"/>
        </el-tab-pane>
      </el-tabs>
    </div>
    <el-button type="text" class="rule-button" @click="exportFile">导出报表</el-button>
  </app-container>
</template>

<script>
import HighFreqList from './highFreqList'
import HighFreqChart from './highFreqChart'
import { highEventList, highCaseEventList, exportAssessHighEvent } from '@/api/assess/assessDept'

export default {
  name: 'HighFreq',
  components: { HighFreqList, HighFreqChart },
  data() {
    return {
      activeName: 'list', // 默认tab
      dialogVisible: false,
      timeRange: [],
      query: {
        begTime: '',
        endTime: ''
      },
      pickerOptions: {
        shortcuts: [{
          text: '最近一周',
          onClick(picker) {
            const end = new Date()
            const start = new Date()
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 7)
            picker.$emit('pick', [start, end])
          }
        }, {
          text: '最近一个月',
          onClick(picker) {
            const end = new Date()
            const start = new Date()
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 30)
            picker.$emit('pick', [start, end])
          }
        }, {
          text: '最近三个月',
          onClick(picker) {
            const end = new Date()
            const start = new Date()
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 90)
            picker.$emit('pick', [start, end])
          }
        }]
      },
      list: [], // 按小类分类
      listMajor: [] // 按大类分类
    }
  },
  watch: {
    timeRange(val) {
      if (val && val.length > 0) {
        this.query.begTime = val[0]
        this.query.endTime = val[1]
      } else {
        this.query.begTime = ''
        this.query.endTime = ''
      }
    }
  },
  mounted() {
    this.fetchData()
  },
  methods: {
    handleClick(tab, event) {
      this.activeName = tab.name
      if (tab.name === 'chart') {
        setTimeout(() => {
          tab.$children[0].initChart()
        }, 50)
      }
    },
    fetchData() {
      highEventList(this.query).then(res => {
        this.list = res.data
      })
      highCaseEventList(this.query).then(res => {
        this.listMajor = res.data
      })
    },
    search() {
      this.fetchData()
    },
    exportFile() {
      // 全屏加载动画
      const loading = this.$loading({
        lock: true,
        text: '数据处理中,请稍后...',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })
      exportAssessHighEvent(this.query).then(res => {
        loading.close() // 关闭加载动画
        console.log('download===', res)
        const blob = new Blob([res.data])
        const downloadElement = document.createElement('a')
        const href = window.URL.createObjectURL(blob) // 创建下载的链接
        downloadElement.href = href
        downloadElement.download = `高发问题列表.xlsx` // 下载后文件名
        document.body.appendChild(downloadElement)
        downloadElement.click() // 点击下载
        document.body.removeChild(downloadElement) // 下载完成移除元素
        window.URL.revokeObjectURL(href) // 释放blob对象
      }).catch((res) => {
        loading.close()
        this.$message.error(res.message)
      })
    }
  }
}
</script>

<style scoped>
  .tab-block{
    border-top: 12px solid #ebebeb;
    padding: 10px;
  }
  .rule-button{
    position: absolute;
    top: 76px;
    right: 10px;
    /* color: red; */
  }
</style>
